EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_OBJECT_ANIMATION_EVENT_ANIMATION_CHANGED =
   EFL_EVENT_DESCRIPTION("animation,changed");
EVAS_API EVAS_API_WEAK const Efl_Event_Description _EFL_CANVAS_OBJECT_ANIMATION_EVENT_ANIMATION_PROGRESS_UPDATED =
   EFL_EVENT_DESCRIPTION("animation_progress,updated");

Efl_Canvas_Animation *_efl_canvas_object_animation_animation_get(const Eo *obj, Efl_Canvas_Object_Animation_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_object_animation_get, Efl_Canvas_Animation *, NULL);

double _efl_canvas_object_animation_animation_progress_get(const Eo *obj, Efl_Canvas_Object_Animation_Data *pd);


static Eina_Value
__eolian_efl_canvas_object_animation_animation_progress_get_reflect(const Eo *obj)
{
   double val = efl_canvas_object_animation_progress_get(obj);
   return eina_value_double_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_object_animation_progress_get, double, 0);

void _efl_canvas_object_animation_animation_pause_set(Eo *obj, Efl_Canvas_Object_Animation_Data *pd, Eina_Bool pause);


static Eina_Error
__eolian_efl_canvas_object_animation_animation_pause_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_canvas_object_animation_pause_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_canvas_object_animation_pause_set, EFL_FUNC_CALL(pause), Eina_Bool pause);

Eina_Bool _efl_canvas_object_animation_animation_pause_get(const Eo *obj, Efl_Canvas_Object_Animation_Data *pd);


static Eina_Value
__eolian_efl_canvas_object_animation_animation_pause_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_canvas_object_animation_pause_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_canvas_object_animation_pause_get, Eina_Bool, 0);

void _efl_canvas_object_animation_animation_start(Eo *obj, Efl_Canvas_Object_Animation_Data *pd, Efl_Canvas_Animation *animation, double speed, double starting_progress);

static void
_efl_canvas_object_animation_start_ownership_fallback(Efl_Canvas_Animation *animation, double speed, double starting_progress)
{
   efl_del(animation);
   (void)speed;
   (void)starting_progress;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV_FALLBACK(efl_canvas_object_animation_start, _efl_canvas_object_animation_start_ownership_fallback(animation, speed, starting_progress);, EFL_FUNC_CALL(animation, speed, starting_progress), Efl_Canvas_Animation *animation, double speed, double starting_progress);

void _efl_canvas_object_animation_animation_stop(Eo *obj, Efl_Canvas_Object_Animation_Data *pd);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODY(efl_canvas_object_animation_stop);

static Eina_Bool
_efl_canvas_object_animation_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_CANVAS_OBJECT_ANIMATION_EXTRA_OPS
#define EFL_CANVAS_OBJECT_ANIMATION_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_canvas_object_animation_get, _efl_canvas_object_animation_animation_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_animation_progress_get, _efl_canvas_object_animation_animation_progress_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_animation_pause_set, _efl_canvas_object_animation_animation_pause_set),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_animation_pause_get, _efl_canvas_object_animation_animation_pause_get),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_animation_start, _efl_canvas_object_animation_animation_start),
      EFL_OBJECT_OP_FUNC(efl_canvas_object_animation_stop, _efl_canvas_object_animation_animation_stop),
      EFL_CANVAS_OBJECT_ANIMATION_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"animation_progress", NULL, __eolian_efl_canvas_object_animation_animation_progress_get_reflect},
      {"animation_pause", __eolian_efl_canvas_object_animation_animation_pause_set_reflect, __eolian_efl_canvas_object_animation_animation_pause_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_canvas_object_animation_class_desc = {
   EO_VERSION,
   "Efl.Canvas.Object_Animation",
   EFL_CLASS_TYPE_MIXIN,
   sizeof(Efl_Canvas_Object_Animation_Data),
   _efl_canvas_object_animation_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_canvas_object_animation_mixin_get, &_efl_canvas_object_animation_class_desc, NULL, NULL);
